"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.defaultRenderers = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// If you don't override the render components,
// we have convenient defaults
var defaultRenderers = {
  loading: function loading() {
    return _react.default.createElement("div", null, "Loading");
  },
  error: function error(_ref) {
    var _error = _ref.error,
        sendRequest = _ref.sendRequest;
    return _react.default.createElement("div", null, "Error in API response: ", _error.toString(), " ");
  },
  loaded: function loaded(_ref2) {
    var data = _ref2.data;
    return _react.default.createElement("pre", null, JSON.stringify(data, null, 2));
  },
  debug: function debug() {
    return _react.default.createElement("div", null, "DEBUG=true set but no debug component specified");
  }
};
exports.defaultRenderers = defaultRenderers;

var _default = function _default(input, render, options) {
  if (typeof render === "function") render = {
    loaded: render
  };
  render = _objectSpread({}, defaultRenderers, {}, render);
  var response = input.response && input.response.data ? input.response : input;

  var withDebug = function withDebug(main) {
    return options.debug ? _react.default.createElement(_react.default.Fragment, null, main, render.debug(_objectSpread({}, response))) : main;
  };

  if (response.error) return withDebug(render.error(response));
  if (_lodash.default.isEmpty(response) || !response.data) return withDebug(render.loading());
  if (response.data) return withDebug(render.loaded(response));
  return _react.default.createElement("div", null, "RenderAsyncComponent never got any anything?");
};

exports.default = _default;