"use strict";

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _buildAPIHooks = _interopRequireDefault(require("./buildAPIHooks"));

var _DebugRequestPanel = _interopRequireDefault(require("./DebugRequestPanel"));

var _lodash = _interopRequireDefault(require("lodash"));

var _DRFObject = _interopRequireDefault(require("./DRFObject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var api = (0, _buildAPIHooks.default)("", {
  headers: {
    Authorization: "Token blahblahblahasdfdeadbeef"
  },
  checkErrors: function checkErrors(r, json) {
    return json.detail === "Not found." && "Not found.";
  },
  debug: true
}, {
  loading: function loading() {
    return _react.default.createElement("div", null, "OVERRIDE THE LOADING MESSAGE");
  },
  debug: function debug(request) {
    return _react.default.createElement(_DebugRequestPanel.default, request);
  }
});

function App() {
  return (0, _DRFObject.default)(api, "subscriptions", "44fa01b2", function (_ref) {
    var details = _ref.details,
        data = _ref.data,
        update = _ref.update,
        fields = _ref.fields;
    if (_lodash.default.isEmpty(data)) return null;
    fields.populateFromDetails();
    return _react.default.createElement("div", null, "Got object #", data.id, " from Subscription API", _lodash.default.map(fields.items, function (field, key) {
      return _react.default.createElement(_react.default.Fragment, {
        key: key
      }, _react.default.createElement("div", null, _react.default.createElement("input", {
        defaultValue: data[key],
        checked: field.type === "boolean" ? data[key] : null,
        disabled: field.read_only,
        onChange: function onChange(e) {
          return update.setField(key, e);
        },
        id: key
      }), _react.default.createElement("label", {
        htmlFor: key
      }, field.label, field.required ? _react.default.createElement("span", {
        style: {
          color: "red"
        }
      }, "*") : null)));
    }), _react.default.createElement("button", {
      onClick: function onClick() {
        return update.sendRequest();
      }
    }, "Save"), _react.default.createElement("button", {
      onClick: function onClick() {
        return details.sendRequest();
      }
    }, "Reload Details"), details.response.pending ? "Refreshing..." : null, update.response.pending ? "Submitting..." : null, update.response.loaded ? api.AsyncComponent(update.response, function () {
      return _react.default.createElement("div", null, "Saved!");
    }) : null);
  });
}

var rootElement = document.getElementById("root");

_reactDom.default.render(_react.default.createElement(App, null), rootElement);