"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _useHTTPCall = _interopRequireDefault(require("./useHTTPCall"));

var _RenderAsyncComponent = _interopRequireDefault(require("./RenderAsyncComponent"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(base_url) {
  var base_options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var render_api = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  var useAPI = function useAPI(stub, options) {
    return (0, _useHTTPCall.default)(base_url + stub, _objectSpread({}, base_options, {}, options));
  };

  var AsyncComponent = function AsyncComponent(response, render, options) {
    var merged_render = _lodash.default.merge({}, render_api, render);

    var merged_options = _lodash.default.merge({}, base_options, options);

    return (0, _RenderAsyncComponent.default)(response, merged_render, merged_options);
  };

  return {
    useAPI: useAPI,
    useGET: function useGET(stub, options) {
      return useAPI(stub, options);
    },
    usePOST: function usePOST(stub, options) {
      return useAPI(stub, _objectSpread({}, options, {
        method: "POST"
      }));
    },
    useOPTIONS: function useOPTIONS(stub, options) {
      return useAPI(stub, _objectSpread({}, options, {
        method: "OPTIONS"
      }));
    },
    usePUT: function usePUT(stub, options) {
      return useAPI(stub, _objectSpread({}, options, {
        method: "PUT"
      }));
    },
    usePATCH: function usePATCH(stub, options) {
      return useAPI(stub, _objectSpread({}, options, {
        method: "PATCH"
      }));
    },
    AsyncComponent: AsyncComponent
  };
};

exports.default = _default;